package treesettest;

import javax.persistence.*;
import java.util.List;
import java.util.Set;

public class Main {

    static EntityManagerFactory emf =
            Persistence.createEntityManagerFactory("treesettest.odb");
    static EntityManager em = emf.createEntityManager();
    static List<DropdownCategory> categories;

    public static void main(String[] args) {

        try {
            categories = em.createQuery("SELECT ddc FROM DropdownCategory ddc", DropdownCategory.class).getResultList();
            System.out.println(categories);
            if (categories.isEmpty()) {
                //store some categories and values
                System.out.println("Storing some categories...");
                DropdownCategory ddc;
                DropdownValue ddv;
                em.getTransaction().begin();
                for (int i = 1; i <= 10; i++) {
                    ddv = new DropdownValue("TestValue" + i);
                    ddc = new DropdownCategory("TestCategory" + i);
                    ddc.getDropdownValues().add(ddv);
                    em.persist(ddc);
                }
                em.getTransaction().commit();
                categories = em.createQuery("SELECT ddc FROM DropdownCategory ddc", DropdownCategory.class).getResultList();
                System.out.println("Printing out the entities that were just persisted....");
                for (DropdownCategory category : categories) {
                    System.out.println(category.toString() + ", value = " + category.getDropdownValues());
                }
            }
            System.out.println("Printing out the stored entities....");
            for (DropdownCategory category : categories) {
                System.out.println(category.toString() + ", value = " + category.getDropdownValues());
            }
            System.out.println("Now try and call \"category.getDropdownValues()\" on the first category...");
            DropdownCategory category = em.createQuery("SELECT ddc FROM DropdownCategory ddc WHERE ddc.id = 1", DropdownCategory.class).getSingleResult();

            //the NullPointerException is thrown on the line below but only on a second run through,
            //it works ok the first time it is run when the categories and values are initially persisted
            Set<DropdownValue> values = category.getDropdownValues();
            System.out.println(values);

        } finally {
            emf.close();
        }
    }
}